;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
print "A block that bounces you up and disappears in a poof if you're spinjumping or on Yoshi but that will damage you if you are not."
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide
JMP SpriteV    : JMP SpriteH    : JMP MarioCape : JMP MarioFireball
JMP TopCorner  : JMP BodyInside : JMP HeadInside

TopCorner:
MarioAbove:
	LDA $140D	; Spinjumping flag
	ORA $187A	; Riding Yoshi flag
	BEQ Damage	; Damage the player if not spinjumping and not riding yoshi

	LDA #$D0	; Low Bounce Height
	BIT $15		; Test controller bits
	BPL +		; Continue if holding A/B
	LDA #$A8	; High Bounce Height
+	STA $7D		; Make the player bounce

	LDA #$07	; Play sound "Shatter block"
	STA $1DFC

	PHB
	LDA #$02
	PHA
	PLB
	LDA #$00	; Set to 0 for normal explosion, 1 for rainbow (throw blocks)
	JSL $028663	; Breaking effect
	PLB

	LDA #$02	; Replace block with blank tile
	STA $9C
	JML $00BEB0

Damage:
MarioSide:
BodyInside:
HeadInside:
	JML $00F5B7

Return:
MarioBelow:
SpriteV:
SpriteH:
MarioCape:
MarioFireball:
	RTL
