;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
print "A block that bounces you up and shatters if you're spinjumping or on Yoshi but that will damage you if you are not."
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

db $42
JMP MarioBelow : JMP MarioAbove : JMP MarioSide
JMP SpriteV    : JMP SpriteH    : JMP MarioCape : JMP MarioFireball
JMP TopCorner  : JMP BodyInside : JMP HeadInside

TopCorner:
MarioAbove:
	LDA $140D	; Spinjumping flag
	ORA $187A	; Riding Yoshi flag
	BEQ Damage	; Damage the player if not spinjumping and not riding yoshi

	LDA #$D0	; Low Bounce Height
	BIT $15		; Test controller bits
	BPL +		; Continue if holding A/B
	LDA #$A8	; High Bounce Height
+	STA $7D		; Make the player bounce

	LDA #$25	; Play sound "Kill enemy with a spin jump"
	STA $1DFC

	LDY #$03	; Set up loop to check for free smoke sprite slot

Loop:
	LDA $17C0,y	;
	BNE Next	;

	LDA #$01	; Initialize smoke sprite
	STA $17C0,y	;
	LDA #$1B	;
	STA $17CC,y	;

	LDA $98		; Smoke Sprite Y-position
	AND #$F0 
	STA $17C4,y

	LDA $9A		; Smoke Sprite X-position
	AND #$F0
	STA $17C8,y

	BRA Erase

Next:
	DEY
	BPL Loop

Erase:
	LDA #$02	; Replace block with blank tile
	STA $9C
	JML $00BEB0

Damage:
MarioSide:
BodyInside:
HeadInside:
	JML $00F5B7

Return:
MarioBelow:
SpriteV:
SpriteH:
MarioCape:
MarioFireball:
	RTL
